-------------------------------------------------------------------------------- 
-- UPC - EETAC - EEL - CSD - DIGSYS       
--------------------------------------------------------------------------------
-- P2. Example on the description of a MUX4 in behavioural way 
-- The circuit's truth table translated to VHDL using an schematic that has 
-- the vector wire X_in
--------------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use ieee.numeric_std.all;

ENTITY  MUX4 is
	port(	E_L 	:	in std_logic;
			Ch0		:	in std_logic;
			Ch1		:	in std_logic;
			Ch2		:	in std_logic;
			Ch3		:	in std_logic;
			Sel		:	in std_logic_vector(1 downto 0);
			y		:	out std_logic
		);
end MUX4;

ARCHITECTURE truth_table OF MUX4 IS

SIGNAL  X_in 	: STD_LOGIC_VECTOR (5 downto 0);
BEGIN
 	 		 		   	   
	Y <= '0'when std_match(X_in,"00---0") and E_L = '0' else  
		 '1'when std_match(X_in,"00---1") and E_L = '0' else  
		 '0'when std_match(X_in,"01--0-") and E_L = '0' else  
		 '1'when std_match(X_in,"01--1-") and E_L = '0' else  
		 '0'when std_match(X_in,"10-0--") and E_L = '0' else  
		 '1'when std_match(X_in,"10-1--") and E_L = '0' else  
		 '0'when std_match(X_in,"110---") and E_L = '0' else  
		 '1'when std_match(X_in,"111---") and E_L = '0' else 
		 '0';  
	
		
-- Extra logic (simple buffers in this case)

X_in(5) <= Sel(1);
X_in(4) <= Sel(0);
X_in(3) <= Ch3;
X_in(2) <= Ch2;
X_in(1) <= Ch1;
X_in(0) <= Ch0;
 	 		 		   	   
END truth_table;